/**
 * $RCSfile: editor_plugin_src.js,v $
 * $Revision: 1.16 $
 * $Date: 2006/03/14 17:33:39 $
 *
 * @author Moxiecode
 * @copyright Copyright  2004-2006, Moxiecode Systems AB, All rights reserved.
 */

/* Import plugin specific language pack */
tinyMCE.importPluginLanguagePack('autoscroll', 'en,tr,sv,cs,fr_ca,zh_cn,da,he,nb,de,hu,ru,ru_KOI8-R,ru_UTF-8,nn,es,cy,is,pl,nl,fr,pt_br');

var TinyMCE_autoscrollPlugin = {
	getInfo : function() {
		return {
			longname : 'autoscroll',
			author : 'Moxiecode Systems',
			authorurl : 'http://tinymce.moxiecode.com',
			infourl : 'http://tinymce.moxiecode.com/tinymce/docs/plugin_autoscroll.html',
			version : tinyMCE.majorVersion + "." + tinyMCE.minorVersion
		};
	},

	getControlHTML : function(cn) {
		switch (cn) {
			case "autoscroll":
				return tinyMCE.getButtonHTML(cn, 'lang_autoscroll_desc', '{$pluginurl}/images/autoscroll.gif', 'mceautoscroll');
		}

		return "";
	},
	
	initInstance : function(inst) {
		
		jc_setparam('jc_messagescroll', '1');
		tinyMCE.switchClass(inst.editorId + '_autoscroll', 'mceButtonSelected');

	},
	
	execCommand : function(editor_id, element, command, user_interface, value) {
		// Handle commands
		switch (command) {
			case "mceautoscroll":
				if (tinyMCE.getParam('autoscroll_is_enabled')) {
					
					jc_setparam('jc_messagescroll', '');
					//document.forms['jc_configuration'].elements['jc_messagescroll'].value == '0';					
					tinyMCE.triggerNodeChange(false);
					
				} else {
					
					if (jc_getparam('jc_messagescroll')){
						jc_setparam('jc_messagescroll', '');
						tinyMCE.switchClass(editor_id + '_autoscroll', 'mceButtonNormal');
					} else {
						jc_setparam('jc_messagescroll', '1');
						tinyMCE.switchClass(editor_id + '_autoscroll', 'mceButtonSelected');
					}
									
				}
		
				return true;
		}

		// Pass to next handler in chain
		return false;
	},

	handleNodeChange : function(editor_id, node, undo_index, undo_levels, visual_aid, any_selection) {
		if (tinyMCE.getParam('autoscroll_is_enabled'))
			tinyMCE.switchClass(editor_id + '_autoscroll', 'mceButtonSelected');

		return true;
	}
};
//document.write('<pre>' + dump(tinyMCE) + '</pre>');
tinyMCE.addPlugin("autoscroll", TinyMCE_autoscrollPlugin);
