/**
 * $RCSfile: editor_plugin_src.js,v $
 * $Revision: 1.16 $
 * $Date: 2006/03/14 17:33:39 $
 *
 * @author Moxiecode
 * @copyright Copyright  2004-2006, Moxiecode Systems AB, All rights reserved.
 */

/* Import plugin specific language pack */
tinyMCE.importPluginLanguagePack('pm', 'en,tr,sv,cs,fr_ca,zh_cn,da,he,nb,de,hu,ru,ru_KOI8-R,ru_UTF-8,nn,es,cy,is,pl,nl,fr,pt_br');

var TinyMCE_pmPlugin = {
	getInfo : function() {
		return {
			longname : 'pm',
			author : 'Moxiecode Systems',
			authorurl : 'http://tinymce.moxiecode.com',
			infourl : 'http://tinymce.moxiecode.com/tinymce/docs/plugin_pm.html',
			version : tinyMCE.majorVersion + "." + tinyMCE.minorVersion
		};
	},
	
	initInstance : function(inst) {
		
		var instele = inst.getDoc();
		
		inst.addShortcut('ctrl', 'p', 'lang_def_desc', 'mcepm');
		
	},
	
	getControlHTML : function(cn) {
		switch (cn) {
			case "pm":
				
				return tinyMCE.getButtonHTML(cn, 'lang_pm_desc', '{$pluginurl}/images/pm.gif', 'mcepm');
		}

		return "";
	},

	execCommand : function(editor_id, element, command, user_interface, value) {
		// Handle commands
		switch (command) {
			case "mcepm":
				
				if (confirm(exitconfirm)){ 
					jc_exit();
				};
								
				return true;
		}

		// Pass to next handler in chain
		return false;
	},

	handleNodeChange : function(editor_id, node, undo_index, undo_levels, visual_aid, any_selection) {
		if (tinyMCE.getParam('pm_is_enabled'))
			tinyMCE.switchClass(editor_id + '_pm', 'mceButtonSelected');

		return true;
	}
};

tinyMCE.addPlugin("pm", TinyMCE_pmPlugin);
