/**
 * $RCSfile: editor_plugin_src.js,v $
 * $Revision: 1.16 $
 * $Date: 2006/03/14 17:33:39 $
 *
 * @author Moxiecode
 * @copyright Copyright  2004-2006, Moxiecode Systems AB, All rights reserved.
 */

/* Import plugin specific language pack */
tinyMCE.importPluginLanguagePack('send', 'en,tr,sv,cs,fr_ca,zh_cn,da,he,nb,de,hu,ru,ru_KOI8-R,ru_UTF-8,nn,es,cy,is,pl,nl,fr,pt_br');

var TinyMCE_sendPlugin = {
	getInfo : function() {
		return {
			longname : 'send',
			author : 'Moxiecode Systems',
			authorurl : 'http://tinymce.moxiecode.com',
			infourl : 'http://tinymce.moxiecode.com/tinymce/docs/plugin_send.html',
			version : tinyMCE.majorVersion + "." + tinyMCE.minorVersion
		};
	},
	
	initInstance : function(inst) {
		
		var instele = inst.getDoc();
		
		inst.addShortcut('ctrl', 's', 'lang_def_desc', 'mcesend');
		tinyMCE.addEvent(inst.getDoc(), "keyup", TinyMCE_sendPlugin._shift);
		tinyMCE.addEvent(inst.getDoc(), "keydown", TinyMCE_sendPlugin._keydown);
	},
	
	_shift : function(event) {
		
		ev = event || window.event;             
		kCode = ev.keyCode || ev.which;   
	
		if (!ev.shiftKey) {	
			
			if (kCode == 13) { 
				if (tinyMCE.isOpera){
					alert('Use CTRL+S to Send');
				} else {
					tinyMCE.execInstanceCommand('mce_editor_0','mcesend');
					tinyMCE.getInstanceById('mce_editor_0').execCommand('mceSetContent', false, false);
				}
			return false;
			} 
		}
	
	},
	
	_keydown : function(event) {
		
		clearTimeout(timerID);
		timerID = setTimeout("getdata()", 2000);
	
	},
	
	getControlHTML : function(cn) {
		switch (cn) {
			case "send":
				
				return tinyMCE.getButtonHTML(cn, 'lang_send_desc', '{$pluginurl}/images/send.gif', 'mcesend');
		}

		return "";
	},

	execCommand : function(editor_id, element, command, user_interface, value) {
		// Handle commands
		switch (command) {
			case "mcesend":
				
				var message = tinyMCE.getContent();
				
				var isspace = message.substring(0,6);
	
				if(isspace == '&nbsp;'){
					var cvalue = 0;
					var message 	= message.substring(6,message.length);
				}
				
				var isbreak = message.substring((message.length - 12),message.length);
				
				if(isbreak == '<br /><br />'){
					var message 	= message.substring(0,(message.length - 12));
				}
				
				var isbreak2 = message.substring((message.length - 6),message.length);
				
				if(isbreak2 == '<br />'){
					var message 	= message.substring(0,(message.length - 6));
				}
				
				if(message){
					sendmessage(message);
				}
				
				
				tinyMCE.getInstanceById('mce_editor_0').execCommand('mceSetContent', false, false);	
				

				return true;
		}

		// Pass to next handler in chain
		return false;
	},

	handleNodeChange : function(editor_id, node, undo_index, undo_levels, visual_aid, any_selection) {
		if (tinyMCE.getParam('send_is_enabled'))
			tinyMCE.switchClass(editor_id + '_send', 'mceButtonSelected');

		return true;
	}
};

tinyMCE.addPlugin("send", TinyMCE_sendPlugin);
