<?php
// THE WEBVIDA THEME ENGINE
// ----------------------------------------------------------------------
// Original Author of file: Adam Docherty aka Lobos
// Contact: www.webvida.com 
// Copyright(c) 2006 ALL RIGHTS RESERVED
// ----------------------------------------------------------------------
// LICENSE
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/lgpl.html
// ----------------------------------------------------------------------

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

function wteComponentInit($sname){
	
	$sabbrv = $sname{0}.$sname{1}.$sname{2};
	
	if($sabbrv == 'mod'){
		$sdir = 'modules';
	
	} else {
		$sdir = 'components';
	}
	
	$cur_template 	= $GLOBALS['cur_template'];
	$lang			= $GLOBALS['mosConfig_lang'];
	
	$themetemplatedir 	= 'templates/'.$cur_template.'/templates/'.$sdir.'/'.$sname;
	
	$themelangfile 		= $themetemplatedir.'/lang/'.$lang.'/global.php';
	$comtemplatedir 	= $sdir.'/'.$sname.'/templates';
	$comlangfile 		= $comtemplatedir.'/lang/'.$lang.'/global.php';
	
	if (!file_exists($themelangfile)) {
		$themelangfile 		= $themetemplatedir.'/lang/english/global.php';
	}
	
	if (!file_exists($comlangfile)) {
		$comlangfile 		= $comtemplatedir.'/lang/english/global.php';
	}
	
	if (file_exists($themelangfile)) {
            require_once($themelangfile);
			
    } else if (file_exists($comlangfile)) {
            require_once($comlangfile);
    }
	
	$wte['com_name'] = str_replace('com_', '', mosGetParam( $_REQUEST,'option',''));
	
	$func = mosGetParam( $_REQUEST,'func','');
	
	if(!$func){
		$func = 'main';
	}
	
	$funcname = $wte['com_name'].'_'.$func;
	
	if (function_exists($funcname)) {
	   $funcname();
	} else {
		echo '<strong>ERROR: function '.$funcname.' not found in components/com_'
		.$wte['com_name'].'/'.$wte['com_name'].'.php</strong>';
	}
}

function wteComAPIFunc($comname, $apiname, $function, $args){
	
	$apifile = 'components/com_'.$comname.'/'.$apiname.'_api.php';
	
	if (!file_exists($apifile)) {
		echo 'Failed to load '.$apifile.' - file does not exist';
		return false;
	} 
	
	require_once('components/com_'.$comname.'/'.$apiname.'_api.php');
	
	$funcname = $comname.'_'.$apiname.'api_'.$function;
	
	if (function_exists($funcname)) {
	   return $funcname($args);
	} else {
		echo 'ERROR: function '.$funcname.' not found in '.$apifile;
		return false;
	}	
}

function wteModuleInit($modname){
	
	$funcname = $modname.'_main';
	require_once('modules/'.$modname.'/'.$modname.'.php');
	
		if (function_exists($funcname)) {
		   return $funcname();
		} else {
			echo '<strong>ERROR: function '.$funcname.' not found in modules/'
			.$modname.'.php</strong>';
		}
}

function wteModAPIFunc($modname, $apiname, $function, $args){
	
	$apifile = 'modules/mod_'.$modname.'/'.$apiname.'_api.php';
	
	if (!file_exists($apifile)) {
		echo 'Failed to load '.$apifile.' - file does not exist';
		return false;
	} 
	
	require_once('modules/mod_'.$modname.'/'.$apiname.'_api.php');
	
	$funcname = 'mod_'.$modname.'_'.$apiname.'api_'.$function;
	
	if (function_exists($funcname)) {
	   return $funcname($args);
	} else {
		echo 'ERROR: function '.$funcname.' not found in '.$apifile;
		return false;
	}	
}

function wte_render($sname, $assign, $filename, $output_type) {
	
	global $wte, $admin_cfg;
	
	$sabbrv = $sname{0}.$sname{1}.$sname{2};
	
	if($sabbrv == 'mod'){
		$sdir = 'modules';
	
	} else {
		$sdir = 'components';
	}
	
	if(!class_exists('smarty')){
		require_once($sdir.'/'.$sname.'/library/smarty/Smarty.class.php');
	}
	
	$platform 		= 'joomla';
	$cur_template 	= $GLOBALS['cur_template'];
	$lang			= $GLOBALS['mosConfig_lang'];
	
	$output			= new smarty;
	
	$output->left_delimiter 	= '<!--[';
	$output->right_delimiter 	= ']-->';		
	$output->cache_dir 			= $sdir.'/'.$sname.'/templates/_cache';        
	$output->compile_check 		= false;
	   
	if($GLOBALS['wte_forcecompile']){
		$output->force_compile 	= true;   
	}     
	 
	$output->use_sub_dirs 		= false;       
	$output->compile_dir 		= $sdir.'/'.$sname.'/templates/_compiled';
	
	$output->plugins_dir[] 		= $sdir.'/'.$sname.'/library/smarty/plugins/';
	
	$themetemplatedir 	= 'templates/'.$cur_template.'/templates/'.$sdir.'/'.$sname;
	
	$themelangfile 		= $themetemplatedir.'/lang/'.$lang.'/global.php';
	$comtemplatedir 	= $sdir.'/'.$sname.'/templates';
	$comlangfile 		= $comtemplatedir.'/lang/'.$lang.'/global.php';
	
	if (!file_exists($themelangfile)) {
		$themelangfile 		= $themetemplatedir.'/lang/english/global.php';
	}
	
	if (!file_exists($comlangfile)) {
		$comlangfile 		= $comtemplatedir.'/lang/english/global.php';
	}
	
	if (file_exists($themelangfile)) {
            require_once($themelangfile);
			
    } else if (file_exists($comlangfile)) {
            require_once($comlangfile);
    }
	
    if (file_exists($themetemplatedir.'/plugins')) {
            array_push($output->plugins_dir, $themetemplatedir.'/plugins');
			
    } else if (file_exists($comtemplatedir.'/plugins')) {
            array_push($output->plugins_dir, $comtemplatedir.'/plugins');
    }
	
	$assign['software'] = $sname;
	
	if (file_exists($themetemplatedir.'/'.$filename)) {
		$dir 	= $themetemplatedir;
		$assign['imagepath'] 	= $themetemplatedir.'/images/';
		$assign['templatedir'] = $themetemplatedir.'/';
	} else {
		$dir 	= $comtemplatedir;
		$assign['imagepath'] 	= $comtemplatedir.'/images/';
		$assign['templatedir'] = $comtemplatedir.'/';
	}
	
	$assign['softwaredir'] = $sdir.'/'.$sname.'/';
	
	$output->template_dir 		= $dir;
	$output->assign				($assign);
		
	if ($output_type == 'fetch'){
		$output = $output->fetch($filename,$cache_id=NULL);
	} 
	else if ($output_type == 'display'){
		$output = $output->display($filename,$cache_id=NULL);
	} 
	else{
		$output = $output->display('error: no output type selected...');
	}

	return $output;
}

?>